SystemOrganization addCategory: #'RPackage-Tests'!

RPackage subclass: #MCMockRPackage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPackage-Tests'!

!MCMockRPackage commentStamp: 'cyrilledelaunay 1/24/2011 16:16' prior: 0!
This class should be used instead of MCMockPackageInfo in the monticello tests!

!MCMockRPackage class methodsFor: 'initialize-release' stamp: '2011-01-24T15:32:00+01:00'!
initialize
	[RPackageOrganizer default registerPackage: self new ] on: MessageNotUnderstood do: []! !

!MCMockRPackage methodsFor: 'as yet unclassified' stamp: '2011-01-24T15:33:00+01:00'!
classNames
	^ #(	MCMockClassA
		 	MCMockASubclass
			MCMockClassB
			MCMockClassD
			MCMockClassE
			MCMockClassF
			MCMockClassG
			MCMockClassH
			MCMockClassI
		)! !

!MCMockRPackage methodsFor: 'as yet unclassified' stamp: '2011-01-24T15:33:00+01:00'!
classes
	^ self classNames select: [ :tmpName | Smalltalk globals hasClassNamed: tmpName ] thenCollect: [ :tmpName | Smalltalk globals at: tmpName ]! !

!MCMockRPackage methodsFor: 'as yet unclassified' stamp: '2011-01-24T15:34:00+01:00'!
includesClass: aClass
	^self classes includes: aClass! !

!MCMockRPackage methodsFor: 'as yet unclassified' stamp: '2011-01-24T15:34:00+01:00'!
includesSystemCategory: categoryName
	^self systemCategories anySatisfy: [:cat | cat sameAs: categoryName]! !

!MCMockRPackage methodsFor: 'as yet unclassified' stamp: '2011-01-24T15:50:00+01:00'!
name

	^ self packageName! !

!MCMockRPackage methodsFor: 'as yet unclassified' stamp: '2011-01-24T15:34:00+01:00'!
packageName
	^ 'MonticelloMocks'! !

!MCMockRPackage methodsFor: 'as yet unclassified' stamp: '2011-01-24T15:35:00+01:00'!
systemCategories
	^ Array with: 'Monticello-Mocks'! !

SystemAnnouncer subclass: #RMockSystemAnnouncer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPackage-Tests'!

RMockSystemAnnouncer class
	instanceVariableNames: 'mockAnnouncer mockDefault'!

RMockSystemAnnouncer class
	instanceVariableNames: 'mockAnnouncer mockDefault'!

!RMockSystemAnnouncer class methodsFor: 'accessing' stamp: '2010-11-18T15:27:00+01:00'!
activateAnnouncerForSystemChanges

	(SystemChangeNotifier uniqueInstance hasNotificationsFor: self)
		ifFalse:  [SystemChangeNotifier uniqueInstance notify: self ofAllSystemChangesUsing: #announceFromEvent:]! !

!RMockSystemAnnouncer class methodsFor: 'accessing' stamp: '2010-11-18T13:03:00+01:00'!
announceFromEvent: aChangeEvent
	"This method creates an announcement from a given Event (subclass of AbstractEvent) and announces it.
	
	For example, from an AddedEvent that concerns a class the method creates SystemAddedClassAnnouncement and then it will announce it both from the generic announcer and from the classAnnouncer "
	self mockAnnouncer announce: aChangeEvent asSystemAnnouncement.! !

!RMockSystemAnnouncer class methodsFor: 'accessing' stamp: '2010-11-18T13:57:00+01:00'!
disableAnnouncerForSystemChanges

	SystemChangeNotifier uniqueInstance noMoreNotificationsFor: self ! !

!RMockSystemAnnouncer class methodsFor: 'initialization' stamp: '2010-11-18T13:28:00+01:00'!
initialize 

	"self initialize"
	mockAnnouncer := Announcer new.! !

!RMockSystemAnnouncer class methodsFor: 'accessing' stamp: '2010-11-18T13:31:00+01:00'!
mockAnnouncer 

	"self mockAnnouncer."
	^ mockAnnouncer   ! !

TestCase subclass: #RPackageTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPackage-Tests'!

RPackageTestCase subclass: #RPackageIncrementalTest
	instanceVariableNames: 'createdClasses createdPackages createdCategories'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPackage-Tests'!

!RPackageIncrementalTest commentStamp: 'StephaneDucasse 5/15/2010 20:21' prior: 0!
The tests takes as fixture the following situation (which is constructed partially)
For tests that do not need to check the incremental construction.


P1 
	A1DefinedInP1>>methodDefinedInP1
	B1DefinedInP1	
	A2DefinedInP2>>methodDefinedInP1  (was *P2)
	
P2
	A2DefinedInP2>>methodDefinedInP2
	B2DefinedInB2	

P3
	A3DefinedInP3	
	A2DefinedInP2>>methodDefinedInP3  (was *P2*)!

RPackageIncrementalTest subclass: #RPackageCompleteSetupButForModificationTest
	instanceVariableNames: 'p1 p2 p3 a1 b1 a2 a3 b2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPackage-Tests'!

!RPackageCompleteSetupButForModificationTest methodsFor: 'setup' stamp: '2010-11-26T09:22:00+01:00'!
setUp
	super setUp.
	p1 := self createNewPackageNamed: self p1Name.
	p2 := self createNewPackageNamed: self p2Name.
	p3 := self createNewPackageNamed: self p3Name.
	
	a1 :=  self createNewClassNamed: #A1DefinedInP1 inPackage: p1.
	b1 := self createNewClassNamed: #B1DefinedInP1 inPackage: p1.
	a2 := self createNewClassNamed: #A2DefinedInP2 inPackage: p2.
	b2 := self createNewClassNamed: #B2DefinedInP2 inPackage: p2.
	a3 := self createNewClassNamed: #A3DefinedInP3 inPackage: p3.
	
	a1 compileSilently: 'methodDefinedInP1 ^ #methodDefinedInP1'.
	p1 addMethod: (a1>>#methodDefinedInP1).
	a1 compileSilently: 'anotherMethodDefinedInP1 ^ #anotherMethodDefinedInP1'.
	p1 addMethod: (a1>>#anotherMethodDefinedInP1).
	
	a2 compileSilently: 'methodDefinedInP1 ^ #methodDefinedInP1'.
	p1 addMethod: (a2>>#methodDefinedInP1).
	
	a2 compileSilently: 'methodDefinedInP2 ^ #methodDefinedInP2'.
	p2 addMethod: (a2>>#methodDefinedInP2).
	
	a2 compileSilently: 'methodDefinedInP3 ^ #methodDefinedInP3'.
	p3 addMethod: (a2>>#methodDefinedInP3).

	a2 class compileSilently: 'classSideMethodDefinedInP3 ^ #classSideMethodDefinedInP3'.
	p3 addMethod: (a2 class>>#classSideMethodDefinedInP3)

! !

!RPackageCompleteSetupButForModificationTest methodsFor: 'test addition' stamp: '2010-04-22T07:53:00+01:00'!
testAddMethod
	"self debug: #testAddMethod"
	
	self assert: (p1 includesSelector: #methodDefinedInP1 ofClass: a1).
	
	a1 compileSilently: 'zork ^ #methodDefinedInP1'.
	p1 addMethod: (a1>>#zork).
	self assert: (p1 includesSelector: #zork ofClass: a1).
	
	self assert: (p3 includesSelector: #classSideMethodDefinedInP3 ofClass: a2 class)
	! !

!RPackageCompleteSetupButForModificationTest methodsFor: 'test addition' stamp: '2010-04-22T07:59:00+01:00'!
testBasicRemoveClass
	"we remove a class we check that it is not in the package anymore"
	"self debug: #testBasicRemoveClass"	

	|  size |
	size := p1 definedClasses size. 
	self assert: size = 2.
	self assert: (p1 includesClass: a1).
	self assert: (p1 includesClass: a1 class).
	p1 removeClassDefinition: a1.
	self assert: p1 definedClasses size = (size - 1).
	self assert: (p1 includesClass: b1).
	self assert: (p1 includesClass: b1 class).
	self deny: (p1 includesClass: a1).
	self deny: (p1 includesClass: a1 class).
	p1 removeClassDefinition: b1.
	self assert: p1 definedClasses size = (size - 2).
	self deny: (p1 includesClass: b1).
	self deny: (p1 includesClass: b1 class).

! !

!RPackageCompleteSetupButForModificationTest methodsFor: 'test starting situation' stamp: '2010-04-24T22:31:00+01:00'!
testExtensionMethodOfClass
	"self debug: #testExtensionMethodOfClass"
	
	"P1 
		A1DefinedInP1>>methodDefinedInP1
		B1DefinedInP1	
		A2DefinedInP2>>methodDefinedInP1  (was *P2)
	
	P2
		A2DefinedInP2>>methodDefinedInP2
		B2DefinedInB2	

	P3
		A3DefinedInP3	
		A2DefinedInP2>>methodDefinedInP3  (was *P2*)"
		
	self assert: a2 methodDict keys size = 3.
	"the class contains methods defined by several packages 
	however when looking with a package view we only see the package 
	extension."
		
	self assert: (p2 extensionMethodsForClass: a2) size = 0.
	self assert: (p1 extensionMethodsForClass: a1) size = 0.
	"show that extensionMethodsForClass: does works for methods of class
	defined in the package"
	
	self assert: (p1 extensionMethodsForClass: a2) size = 1.
	self assert: (p3 extensionMethodsForClass: a2) size = 1.! !

!RPackageCompleteSetupButForModificationTest methodsFor: 'test addition' stamp: '2010-04-24T22:28:00+01:00'!
testRemoveMethod
	"self debug: #testRemoveMethod"
	
	p1 removeMethod: a1 >> #methodDefinedInP1.
	self deny: (p1 includesSelector: #methodDefinedInP1 ofClass: a1).
	! !

!RPackageCompleteSetupButForModificationTest methodsFor: 'test addition' stamp: '2010-04-24T22:27:00+01:00'!
testRemoveMethodDoesNotRemoveFromClass
	"we remove a method so it is not in the package but also not from the class anymore"
	"self debug: #testRemoveMethodDoesNotRemoveFromClass"
	
	p1 removeMethod:  a1 >> #methodDefinedInP1.
	self deny: (p1 includesSelector: #methodDefinedInP1 ofClass: a1).
	self assert: (a1 selectors includes: #methodDefinedInP1)! !

!RPackageCompleteSetupButForModificationTest methodsFor: 'test addition' stamp: '2010-04-24T22:28:00+01:00'!
testRemoveShouldRaiseErrorWhenMethodIsNotInPackage
	"self debug: #testRemoveShouldRaiseErrorWhenMethodIsNotInPackage"
	
	self should: [p2 removeMethod: a2>>#methodDefinedZork] raise: Error! !

!RPackageCompleteSetupButForModificationTest methodsFor: 'test starting situation' stamp: '2010-04-22T07:52:00+01:00'!
testStartingSituation
	"self debug: #testStartingSituation"
	
	self deny: (p2 includesClass: b1).
	self assert: (p2 includesClass: b2).
	"a locally defined class not extended by other packages"
	
	self assert: (p2 includesClass: a2).  
	"a locally defined class extended by other packages"
	
	self assert: (p1 definesOrExtendsClass: a2).
	self deny: (p1 includesClass: a2).! !

!RPackageIncrementalTest methodsFor: 'utility' stamp: '2010-06-13T15:41:00+01:00'!
createNewClassNamed: aName
	^ self createNewClassNamed: aName inCategory: 'RPackageTest'! !

!RPackageIncrementalTest methodsFor: 'utility' stamp: '2010-11-26T09:16:00+01:00'!
createNewClassNamed: aName inCategory: cat
	
	| cls |
	cls := Object subclass: aName
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: cat.
	createdClasses add: cls.
	createdCategories add: cat.
	^ cls! !

!RPackageIncrementalTest methodsFor: 'utility' stamp: '2010-03-11T13:28:00+01:00'!
createNewClassNamed: aName inPackage: p
	
	| cls |
	cls := self createNewClassNamed: aName.
	p addClassDefinition: cls.
	^ cls! !

!RPackageIncrementalTest methodsFor: 'utility' stamp: '2010-06-13T17:26:00+01:00'!
createNewPackageNamed: aName

	| pack |
	self removePackage: aName.
	pack := RPackage named: aName.
	createdPackages add: pack.
	^ pack! !

!RPackageIncrementalTest methodsFor: 'utility' stamp: '2010-11-26T09:18:00+01:00'!
p1Name
	^ 'RPackageTestP1'! !

!RPackageIncrementalTest methodsFor: 'utility' stamp: '2010-11-26T09:23:00+01:00'!
p2Name
	^ 'RPackageTestP2'

! !

!RPackageIncrementalTest methodsFor: 'utility' stamp: '2010-11-26T09:23:00+01:00'!
p3Name
	^ 'RPackageTestP3'

! !

!RPackageIncrementalTest methodsFor: 'utility' stamp: '2010-06-05T18:40:00+01:00'!
packageClass

	^ RPackage! !

!RPackageIncrementalTest methodsFor: 'utility' stamp: '2010-06-13T17:18:00+01:00'!
removeClassNamedIfExists: aClassNameSymbol
	Smalltalk at: aClassNameSymbol asSymbol ifPresent: [:c| c removeFromSystem]! !

!RPackageIncrementalTest methodsFor: 'utility' stamp: '2010-06-13T17:18:00+01:00'!
removePackage: aName
	RPackage organizer unregisterPackageNamed: aName.
	"SystemOrganization removeCategory: aName."! !

!RPackageIncrementalTest methodsFor: 'setup' stamp: '2010-11-26T09:15:00+01:00'!
setUp
	createdClasses := OrderedCollection new.
	createdPackages := OrderedCollection new.
	createdCategories := OrderedCollection new! !

!RPackageIncrementalTest methodsFor: 'setup' stamp: '2010-11-26T09:15:00+01:00'!
tearDown
	createdPackages  do: [:each | self removePackage: each name].
	createdPackages  do: [:each | 
		each extendedClasses do: [ :extendedClass|
			RPackage organizer
		 		unregisterExtendingPackage: each forClass: extendedClass]].
						
	(createdClasses reject: [:c| c isObsolete]) do: [:cls| 
		(RPackage organizer includesClass: cls) ifTrue: [cls package unregisterClass: cls.].
		cls removeFromSystem ].					
	
	createdCategories do: [:each | 
		SystemOrganization removeCategory: each ].! !

!RPackageIncrementalTest methodsFor: 'test class addition removal' stamp: '2010-11-26T09:19:00+01:00'!
testAddClassAfterMethods
	"self debug: #testAddClassAfterMethods"

	| p1 a1 b1 |
	p1 := self createNewPackageNamed: self p1Name.
	"the class is created but not added to the package for now"
	a1 := self createNewClassNamed: #A1InPackageP1 inCategory: self p1Name.
	self assert: p1 definedClasses size = 0.
	
	"now we add a new method to the class and the to the package: it is considered
	as class extension"
	
	a1 compileSilently: 'newlyAddedToA1 ^ #methodDefinedInP1'.
	p1 addMethod: (a1>>#newlyAddedToA1).
	self assert: (p1 includesSelector: #newlyAddedToA1 ofClass: a1).
	self assert: (p1 includesExtensionSelector: #newlyAddedToA1 ofClass: a1).
	self deny: (p1 includesDefinedSelector: #newlyAddedToA1 ofClass: a1).
	
	"Now we add the class and this means that the method is not an extension anymore but 
	a defined method"
	
	p1 addClassDefinition: a1.
	self assert: p1 definedClasses size = 1.
	
	self deny: (p1 includesExtensionSelector: #newlyAddedToA1 ofClass: a1).
	self assert: (p1 includesDefinedSelector: #newlyAddedToA1 ofClass: a1).
	
	
"
	self assert: (p1 includesSelector: #methodDefinedInP1 ofClass: a1).
	self assert: (p3 includesSelector: #classSideMethodDefinedInP3 ofClass: a2 class)
	"! !

!RPackageIncrementalTest methodsFor: 'test class addition removal' stamp: '2010-11-26T09:19:00+01:00'!
testAddClassAfterMethodsAtMetaclassToo
	"self debug: #testAddClassAfterMethodsAtMetaclassToo"

	| p1 a1 b1 |
	p1 := self createNewPackageNamed: self p1Name.
	"the class is created but not added to the package for now"
	a1 := self createNewClassNamed: #A1InPackageP1 inCategory: self p1Name.
	self assert: p1 definedClasses size = 0.
	
	"now we add a new method to the class and the to the package: it is considered
	as class extension"
	
	a1 class compileSilently: 'newlyAddedToA1Class ^ #methodDefinedInP1'.
	p1 addMethod: (a1 class>>#newlyAddedToA1Class).
	self assert: (p1 includesSelector: #newlyAddedToA1Class ofClass: a1 class).
	self assert: (p1 includesExtensionSelector: #newlyAddedToA1Class ofClass: a1 class).
	self deny: (p1 includesDefinedSelector: #newlyAddedToA1Class ofClass: a1 class).
	
	"Now we add the class and this means that the method is not an extension anymore but 
	a defined method"
	
	p1 addClassDefinition: a1.
	self assert: p1 definedClasses size = 1.
	
	self deny: (p1 includesExtensionSelector: #newlyAddedToA1Class ofClass: a1 class).
	self assert: (p1 includesDefinedSelector: #newlyAddedToA1Class ofClass: a1 class).
	
	
"
	self assert: (p1 includesSelector: #methodDefinedInP1 ofClass: a1).
	self assert: (p3 includesSelector: #classSideMethodDefinedInP3 ofClass: a2 class)
	"! !

!RPackageIncrementalTest methodsFor: 'test class addition removal' stamp: '2010-11-26T09:19:00+01:00'!
testAddClassDefinitionNoDuplicate
	"self debug: #testAddClassDefinitionNoDuplicate"

	| p a1 b1 |
	p := self createNewPackageNamed: self p1Name.
	a1 := self createNewClassNamed: #A1InPackageP1 inCategory: self p1Name.
	self assert: p definedClasses size = 0.
	p addClassDefinition: a1.
	self assert: p definedClasses size = 1.
	b1 := self createNewClassNamed: #B1InPackageP1 inCategory: self p1Name.
	p addClassDefinition: a1.
	"adding the same class does not do anything - luckily"
	self assert: p definedClasses size = 1.
	p addClassDefinition: b1.
	self assert: p definedClasses size = 2.
! !

!RPackageIncrementalTest methodsFor: 'test method addition removal' stamp: '2010-06-13T15:47:00+01:00'!
testAddRemoveMethod
	"self debug: #testAddRemoveMethod"
	
	| p1 p2 p3 a2   a2Name |
	a2Name := #A2InPackageP2.
	p1 := self createNewPackageNamed: 'P1'.
	p2 := self createNewPackageNamed: 'P2'.
	p3 := self createNewPackageNamed: 'P3'.
	a2 := self createNewClassNamed: a2Name inPackage: p2.
	a2 compileSilently: 'methodDefinedInP2 ^ #methodDefinedInP2'.
	
	p2 addMethod: (a2>>#methodDefinedInP2).
	a2 compileSilently: 'methodDefinedInP1 ^ #methodDefinedInP1'.
	p1 addMethod: (a2>>#methodDefinedInP1).
	a2 compileSilently: 'methodDefinedInP3 ^ #methodDefinedInP3'.
	p3 addMethod: (a2>>#methodDefinedInP3).
	
	self assert: (p2 includesDefinedSelector: #methodDefinedInP2 ofClassName: a2Name).
	self deny: (p2 includesExtensionSelector: #methodDefinedInP2 ofClassName: a2Name).
	self deny: (p3 includesDefinedSelector: #methodDefinedInP3 ofClassName: a2Name).
	self assert: (p3 includesExtensionSelector: #methodDefinedInP3 ofClassName: a2Name).
	self assert: (p1 includesExtensionSelector: #methodDefinedInP1 ofClassName: a2Name).
	self deny: (p3 includesDefinedSelector: #methodDefinedInP1 ofClassName: a2Name).
	
	"removeMethod by default removes from defined methods and not extension"
	p2 removeMethod: (a2>>#methodDefinedInP2).
	self deny: (p2 includesDefinedSelector: #methodDefinedInP2 ofClassName: a2Name).
	self deny: (p2 includesExtensionSelector: #methodDefinedInP2 ofClassName: a2Name).
	
	p1 removeMethod: (a2>>#methodDefinedInP1).
	self deny: (p1 includesDefinedSelector: #methodDefinedInP3 ofClassName: a2Name).
	self deny: (p1 includesExtensionSelector: #methodDefinedInP3 ofClassName: a2Name).! !

!RPackageIncrementalTest methodsFor: 'test method addition removal' stamp: '2010-06-13T15:46:00+01:00'!
testAddRemoveSelector
	"self debug: #testAddRemoveSelector"
	
	| p1 p2 p3 a2   a2Name |
	a2Name := #A2InPackageP2.
	p1 := self createNewPackageNamed: 'P1'.
	p2 := self createNewPackageNamed: 'P2'.
	p3 := self createNewPackageNamed: 'P3'.
	a2 := self createNewClassNamed: a2Name inPackage: p2.
	a2 compileSilently: 'methodDefinedInP2 ^ #methodDefinedInP2'.
	p2 addSelector: #methodDefinedInP2 ofClassName: a2Name.
	a2 compileSilently: 'methodDefinedInP1 ^ #methodDefinedInP1'.
	p1 addSelector: #methodDefinedInP1 ofClassName: a2Name.
	a2 compileSilently: 'methodDefinedInP3 ^ #methodDefinedInP3'.
	p3 addSelector: #methodDefinedInP3 ofClassName: a2Name.
	
	self assert: (p2 includesDefinedSelector: #methodDefinedInP2 ofClassName: a2Name).
	self deny: (p2 includesExtensionSelector: #methodDefinedInP2 ofClassName: a2Name).
	self deny: (p3 includesDefinedSelector: #methodDefinedInP3 ofClassName: a2Name).
	self assert: (p3 includesExtensionSelector: #methodDefinedInP3 ofClassName: a2Name).
	self assert: (p1 includesExtensionSelector: #methodDefinedInP1 ofClassName: a2Name).
	self deny: (p3 includesDefinedSelector: #methodDefinedInP1 ofClassName: a2Name).
	
	p2 removeSelector: #methodDefinedInP2 ofClassName:  a2Name.
	self deny: (p2 includesDefinedSelector: #methodDefinedInP2 ofClassName: a2Name).
	self deny: (p2 includesExtensionSelector: #methodDefinedInP2 ofClassName: a2Name).
	
	p1 removeSelector: #methodDefinedInP1 ofClassName:  a2Name.
	self deny: (p1 includesDefinedSelector: #methodDefinedInP3 ofClassName: a2Name).
	self deny: (p1 includesExtensionSelector: #methodDefinedInP3 ofClassName: a2Name).! !

!RPackageIncrementalTest methodsFor: 'test method addition removal' stamp: '2010-06-13T15:47:00+01:00'!
testAddRemoveSelectorOfMetaclass
	"self debug: #testAddRemoveSelectorOfMetaclass"
	
	| p1 p2 p3 a2   a2Name a2class |
	a2Name := #A2InPackageP2.
	p1 := self createNewPackageNamed: 'P1'.
	p2 := self createNewPackageNamed: 'P2'.
	p3 := self createNewPackageNamed: 'P3'.
	a2 := self createNewClassNamed: a2Name inPackage: p2.
	a2class := a2 class.
	a2class compileSilently: 'methodDefinedInP2 ^ #methodDefinedInP2'.
	p2 addSelector: #methodDefinedInP2 ofMetaclassName: a2Name.
	a2class compileSilently: 'methodDefinedInP1 ^ #methodDefinedInP1'.
	p1 addSelector: #methodDefinedInP1 ofMetaclassName: a2Name.
	a2class compileSilently: 'methodDefinedInP3 ^ #methodDefinedInP3'.
	p3 addSelector: #methodDefinedInP3 ofMetaclassName: a2Name.
	
	self assert: (p2 includesDefinedSelector: #methodDefinedInP2 ofMetaclassName: a2Name).
	self deny: (p2 includesExtensionSelector: #methodDefinedInP2 ofMetaclassName: a2Name).
	self deny: (p3 includesDefinedSelector: #methodDefinedInP3 ofMetaclassName: a2Name).
	self assert: (p3 includesExtensionSelector: #methodDefinedInP3 ofMetaclassName: a2Name).
	self assert: (p1 includesExtensionSelector: #methodDefinedInP1 ofMetaclassName: a2Name).
	self deny: (p3 includesDefinedSelector: #methodDefinedInP1 ofMetaclassName: a2Name).
	
	p2 removeSelector: #methodDefinedInP2 ofMetaclassName:  a2Name.
	self deny: (p2 includesDefinedSelector: #methodDefinedInP2 ofMetaclassName: a2Name).
	self deny: (p2 includesExtensionSelector: #methodDefinedInP2 ofMetaclassName: a2Name).
	
	p1 removeSelector: #methodDefinedInP1 ofMetaclassName:  a2Name.
	self deny: (p1 includesDefinedSelector: #methodDefinedInP3 ofMetaclassName: a2Name).
	self deny: (p1 includesExtensionSelector: #methodDefinedInP3 ofMetaclassName: a2Name).! !

!RPackageIncrementalTest methodsFor: 'test class addition removal' stamp: '2010-11-26T09:19:00+01:00'!
testBogusClassAddition
	"self debug: #testBogusClassAddition"

	| p a1 |
	p := self createNewPackageNamed: self p1Name.
	a1 := self createNewClassNamed: #A1InPAckageP1 inCategory: self p1Name.
	self assert: p definedClasses size = 0.
	p addClassDefinitionName: a1 name.
	self assert: p definedClasses size = 1.
	self assert: (p includesClass: a1).
	self should: [p addClassDefinitionName: a1 class name] raise: Error.
! !

!RPackageIncrementalTest methodsFor: 'test class addition removal' stamp: '2010-11-26T09:19:00+01:00'!
testClassAddition
	"self debug: #testClassAddition"

	| p a1 |
	p := self createNewPackageNamed: self p1Name.
	a1 := self createNewClassNamed: #A1InPAckageP1 inCategory: self p1Name.
	self assert: p definedClasses size = 0.
	p addClassDefinition: a1.
	self assert: p definedClasses size = 1.
	self assert: (p includesClass: a1).
	self assert: (p includesClass: a1 class)
! !

!RPackageIncrementalTest methodsFor: 'test class addition removal' stamp: '2010-11-26T09:19:00+01:00'!
testClassDefinitionRemoval
	"self debug: #testClassDefinitionRemoval"

	| p a1 b1|
	p := self createNewPackageNamed: self p1Name.
	a1 := self createNewClassNamed: #A1InPAckageP1 inCategory: self p1Name.
	b1 := self createNewClassNamed: #B1InPAckageP1 inCategory: self p1Name.
	self assert: p definedClasses size = 0.
	p addClassDefinition: a1.
	p addClassDefinition: b1.
	self assert: p definedClasses size = 2.
	self assert: (p includesClass: a1).
	self assert: (p includesClass: b1).
	p removeClassDefinition: a1.
	self assert: p definedClasses size = 1.
	self deny: (p includesClass: a1).
	self assert: (p includesClass: b1).
	p removeClassDefinition: b1 class.
	self deny: (p includesClass: b1).
! !

!RPackageIncrementalTest methodsFor: 'test class addition removal' stamp: '2010-11-26T09:19:00+01:00'!
testClassDefinitionRemovalName
	"self debug: #testClassDefinitionRemovalName"

	| p a1 b1|
	p := self createNewPackageNamed: self p1Name.
	a1 := self createNewClassNamed: #A1InPAckageP1 inCategory: self p1Name.
	b1 := self createNewClassNamed: #B1InPAckageP1 inCategory: self p1Name.
	self assert: p definedClasses size = 0.
	p addClassDefinitionName: a1 name.
	p addClassDefinitionName: b1 name.
	self assert: p definedClasses size = 2.
	self assert: (p includesClass: a1).
	self assert: (p includesClass: b1).
	p removeClassDefinitionName: a1 name.
	self assert: p definedClasses size = 1.
	self deny: (p includesClass: a1).
	self assert: (p includesClass: b1).
	self should: [p removeClassDefinitionName: b1 class name] raise: Error.
	p removeClassDefinitionName: b1  name.
	self deny: (p includesClass: b1).
! !

!RPackageIncrementalTest methodsFor: 'test extension' stamp: '2010-06-13T15:47:00+01:00'!
testClasses
	"self debug: #testClasses"
	
	| p1 p2 a2  b2 |
	p1 := self createNewPackageNamed: 'P1'.
	p2 := self createNewPackageNamed: 'P2'.

	a2 := self createNewClassNamed: #A2InPackageP2 inPackage: p2.
	b2 := self createNewClassNamed: #B2InPackageP2 inPackage: p2.
	a2 compileSilently: 'methodPackagedInP1 ^ #methodPackagedInP1'.
	p1 addMethod: (a2>>#methodPackagedInP1).
	b2 class compileSilently: 'methodPackagedInP1 ^ #methodPackagedInP1'.
	p1 addMethod: (b2 class>>#methodPackagedInP1).
	
	self assert: p1 classes size = 2.
	self assert: p2 classes size = 2.! !

!RPackageIncrementalTest methodsFor: 'test class addition removal' stamp: '2010-11-26T09:20:00+01:00'!
testDefinedClassesAndDefinedClassNames
	"self debug: #testDefinedClassesAndDefinedClassNames"

	| p a1 b1 |
	p := self createNewPackageNamed: self p1Name.
	a1 := self createNewClassNamed: #A1InPackageP1 inCategory: self p1Name.
	self assert: p definedClasses size = 0.
	p addClassDefinition: a1.
	self assert: p definedClasses size = 1.
	self assert: (p definedClasses  includes: a1).
	self assert: (p definedClassNames includes: a1 name).
	
	b1 := self createNewClassNamed: #B1InPackageP1 inCategory: self p1Name.
	p addClassDefinition: b1.
	self assert: p definedClasses size = 2.
	self assert: (p definedClasses includes: b1).
	self assert: (p definedClassNames includes: b1 name).
	! !

!RPackageIncrementalTest methodsFor: 'test extension' stamp: '2010-04-25T17:38:00+01:00'!
testExtensionClassNames
	"self debug: #testExtensionClassNames"
	
	| p1 p2  a2 b2 |
	p1 := self createNewPackageNamed: 'P1'.
	p2 := self createNewPackageNamed: 'P2'.
	a2 := self createNewClassNamed: #A2InPackageP2 inPackage: p2.
	b2 := self createNewClassNamed: #B2InPackageP2 inPackage: p2.
	self deny: (p1 includesClass: a2).
	self assert: (p2 includesClass: b2).
	self assert: (p2 includesClass: a2).
	
	a2 compileSilently: 'methodDefinedInP1 ^ #methodDefinedInP1'.
	p1 addSelector: #methodDefinedInP1 ofClassName: a2 name.
	
	self assert: p1 extensionSelectors size = 1.
	self assert: p1 extensionMethods size = 1.
	self assert: (p1 extendedClassNames includes: #A2InPackageP2).
	self deny: (p1 includesClass: a2).
	"method extension class are not included in packages"
	
	b2 compile: 'firstMethodInB2PackagedInP1 ^ 1'.
	p1 addSelector: #firstMethodInB2PackagedInP1 ofClassName: b2 name.
	
	self assert: p1 extensionSelectors  size = 2.
	self assert: p1 extensionMethods  size = 2.
	self assert: (p1 extendedClassNames includes: #B2InPackageP2).
	self deny: (p1 includesClass: b2).
	
	b2 compileSilently: 'secondMethodInB2PackagedInP1 ^ 2'.
	p1 addSelector: #secondMethodInB2PackagedInP1 ofClassName: b2 name.
	
	self assert: p1 extensionSelectors  size = 3.
	self assert: p1 extensionMethods  size = 3.
	self assert: p1 extendedClasses size = 2.
	self assert: (p1 extendedClassNames includes: #B2InPackageP2).
	self deny: (p1 includesClass: b2).! !

!RPackageIncrementalTest methodsFor: 'test extension' stamp: '2010-06-13T15:47:00+01:00'!
testExtensionClasses
	"self debug: #testExtensionClasses"
	
	| p1 p2 a2  b2 |
	p1 := self createNewPackageNamed: 'P1'.
	p2 := self createNewPackageNamed: 'P2'.

	a2 := self createNewClassNamed: #A2InPackageP2 inPackage: p2.
	b2 := self createNewClassNamed: #B2InPackageP2 inPackage: p2.
	self deny: (p1 includesClass: a2).
	self assert: (p2 includesClass: a2).
	
	a2 compileSilently: 'methodPackagedInP1 ^ #methodPackagedInP1'.
	p1 addMethod: (a2>>#methodPackagedInP1).
	
	self assert: p1 extendedClasses size = 1.
	self assert: (p1 extendedClasses  includes: a2).
	self assert: p1 extendedClassNames size = 1.
	self assert: (p1 extendedClassNames  includes: a2 name).
	
	b2 class compileSilently: 'methodPackagedInP1 ^ #methodPackagedInP1'.
	p1 addMethod: (b2 class>>#methodPackagedInP1).
	
	self assert: p1 extendedClasses size = 2.
	self assert: (p1 extendedClasses  includes: b2 class).
	"extensionClasses returns or metaclasses while extensionClassNames returns class names (but not metaclass names)"

	self assert: p1 extendedClassNames size = 2.
	self assert: (p1 extendedClassNames  includes: b2 name).! !

!RPackageIncrementalTest methodsFor: 'test extension' stamp: '2010-04-25T17:45:00+01:00'!
testExtensionClassesWithCompiledMethod
	"self debug: #testExtensionClassesWithCompiledMethod"
	
	| p1 p2  a2 b2 |
	p1 := self createNewPackageNamed: 'P1'.
	p2 := self createNewPackageNamed: 'P2'.
	a2 := self createNewClassNamed: #A2InPackageP2 inPackage: p2.
	b2 := self createNewClassNamed: #B2InPackageP2 inPackage: p2.
	self deny: (p1 includesClass: a2).
	self assert: (p2 includesClass: b2).
	self assert: (p2 includesClass: b2).
	
	a2 compileSilently: 'methodDefinedInP1 ^ #methodDefinedInP1'.
	p1 addMethod: (a2>>#methodDefinedInP1).
	
	self assert: p1 extensionMethods size = 1.
	self assert: p1 extensionSelectors size = 1.
	self assert: p1 extendedClasses size = 1.
	self deny: (p1 includesClass: a2).
	"method extension class are not included in packages"
	
	b2 compile: 'firstMethodInB2PackagedInP1 ^ 1'.
	p1 addMethod: (b2>>#firstMethodInB2PackagedInP1).
	
	self assert: p1 extensionSelectors  size = 2.
	self assert: p1 extensionMethods  size = 2.
	self assert: p1 extendedClasses size = 2.
	self deny: (p1 includesClass: b2).
	
	b2 compileSilently: 'secondMethodInB2PackagedInP1 ^ 2'.
	p1 addMethod: (b2>>#secondMethodInB2PackagedInP1).
	
	self assert: p1 extensionSelectors  size = 3.
	self assert: p1 extensionMethods  size = 3.
	self assert: p1 extendedClasses size = 2.
	self deny: (p1 includesClass: b2).! !

!RPackageIncrementalTest methodsFor: 'test extension' stamp: '2010-04-25T17:13:00+01:00'!
testExtensionMethods
	"self debug: #testExtensionMethods"
	
	| p1 p2 a2  b2 |
	p1 := self createNewPackageNamed: 'P1'.
	p2 := self createNewPackageNamed: 'P2'.

	a2 := self createNewClassNamed: #A2InPackageP2 inPackage: p2.
	b2 := self createNewClassNamed: #B2InPackageP2 inPackage: p2.
	a2 compileSilently: 'methodDefinedInP1 ^ #methodDefinedInP1'.
	p1 addMethod: (a2>>#methodDefinedInP1).
	
	self assert: p1 extensionSelectors  size = 1.
	self deny: (p1 includesClass: a2).
	"method extension class are not included in packages"
	
	b2 compileSilently: 'firstMethodInB2PackagedInP1 ^ 1'.
	p1 addMethod: (b2>>#firstMethodInB2PackagedInP1).
	self assert: p1 extensionSelectors  size = 2.
	! !

!RPackageIncrementalTest methodsFor: 'test extension' stamp: '2010-03-11T14:35:00+01:00'!
testIncludeClass
	"self debug: #testIncludeClass"
	
	| p1 p2 a2  |
	p1 := self createNewPackageNamed: 'P1'.
	p2 := self createNewPackageNamed: 'P2'.
	a2 := self createNewClassNamed: #A2InPackageP2 inPackage: p2.
	a2 compileSilently: 'methodPackagedInP1 ^ #methodPackagedInP1'.
	
	self deny: (p1 includesClass: a2).
	p1 addMethod: (a2>>#methodPackagedInP1).
	self deny: (p1 includesClass: a2).
	"We should declare the class explictly. Adding a method does not declare
	the class as defined. The reason is that like that the client controls the granularity 
	and moment of class registration."
	
	p1 addClassDefinition: a2.
	self assert: (p1 includesClass: a2).
	self assert: (p1 includesClassNamed: a2 name).
	
	! !

!RPackageIncrementalTest methodsFor: 'test extension' stamp: '2010-04-21T09:29:00+01:00'!
testIncludeClassMore
	"self debug: #testIncludeClassMore"
	
	| p1 p2 p3 a2  |
	p1 := self createNewPackageNamed: 'P1'.
	p2 := self createNewPackageNamed: 'P2'.
	p3 := self createNewPackageNamed: 'P3'.
	a2 := self createNewClassNamed: #A2InPackageP2 inPackage: p2.
	a2 compileSilently: 'methodDefinedInP2 ^ #methodDefinedInP2'.
	p2 addMethod: (a2>>#methodDefinedInP2).
	a2 compileSilently: 'methodDefinedInP1 ^ #methodDefinedInP1'.
	p1 addMethod: (a2>>#methodDefinedInP1).
	a2 compileSilently: 'methodDefinedInP3 ^ #methodDefinedInP3'.
	p3 addMethod: (a2>>#methodDefinedInP3).
	
	self assert: (p2 includesClass: a2).
	self deny: (p1 includesClass: a2).
	self deny: (p3 includesClass: a2).! !

!RPackageIncrementalTest methodsFor: 'test extension' stamp: '2010-04-21T09:29:00+01:00'!
testIncludeSelectorOfClass
	"self debug: #testIncludeSelectorOfClass"
	
	| p1 p2 p3 a2  |
	p1 := self createNewPackageNamed: 'P1'.
	p2 := self createNewPackageNamed: 'P2'.
	p3 := self createNewPackageNamed: 'P3'.
	a2 := self createNewClassNamed: #A2InPackageP2 inPackage: p2.
	a2 compileSilently: 'methodDefinedInP2 ^ #methodDefinedInP2'.
	p2 addMethod: (a2>>#methodDefinedInP2).
	a2 compileSilently: 'methodDefinedInP1 ^ #methodDefinedInP1'.
	p1 addMethod: (a2>>#methodDefinedInP1).
	a2 compileSilently: 'methodDefinedInP3 ^ #methodDefinedInP3'.
	p3 addMethod: (a2>>#methodDefinedInP3).
	
	"includesSelector checks both in defined and extension so we test both"
	self assert: (p2 includesSelector: #methodDefinedInP2 ofClass: a2).
	self assert: (p2 includesDefinedSelector: #methodDefinedInP2 ofClassName: a2 name).
	self deny: (p2 includesExtensionSelector: #methodDefinedInP2 ofClassName: a2 name).
	
	self deny: (p2 includesSelector: #methodDefinedInP3 ofClass: a2).
	self assert: (p3 includesExtensionSelector: #methodDefinedInP3 ofClassName: a2 name).
	self deny: (p3 includesDefinedSelector: #methodDefinedInP3 ofClassName: a2 name).
	
	self deny: (p2 includesSelector: #methodDefinedInP1 ofClass: a2).
	self assert: (p1 includesExtensionSelector: #methodDefinedInP1 ofClassName: a2 name).
	self deny: (p3 includesDefinedSelector: #methodDefinedInP1 ofClassName: a2 name).! !

!RPackageIncrementalTest methodsFor: 'test extension' stamp: '2010-04-21T09:29:00+01:00'!
testIncludeSelectorOfMetaClass
	"self debug: #testIncludeSelectorOfMetaClass"
	
	| p1 p2 p3 a2  a2class |
	p1 := self createNewPackageNamed: 'P1'.
	p2 := self createNewPackageNamed: 'P2'.
	p3 := self createNewPackageNamed: 'P3'.
	a2 := self createNewClassNamed: #A2InPackageP2 inPackage: p2.
	a2class := a2 class.
	a2class compileSilently: 'methodDefinedInP2 ^ #methodDefinedInP2'.
	p2 addMethod: (a2class>>#methodDefinedInP2).
	a2class compileSilently: 'methodDefinedInP1 ^ #methodDefinedInP1'.
	p1 addMethod: (a2class>>#methodDefinedInP1).
	a2class compileSilently: 'methodDefinedInP3 ^ #methodDefinedInP3'.
	p3 addMethod: (a2class>>#methodDefinedInP3).
	
	"includesSelector checks both in defined and extension so we test both"
	self assert: (p2 includesSelector: #methodDefinedInP2 ofClass: a2class).
	self assert: (p2 includesDefinedSelector: #methodDefinedInP2 ofMetaclassName: a2 name).
	self assert: (p2 includesDefinedSelector: #methodDefinedInP2 ofClass: a2class).
	self deny: (p2 includesExtensionSelector: #methodDefinedInP2 ofMetaclassName: a2 name).
	
	self deny: (p2 includesSelector: #methodDefinedInP3 ofClass: a2).
	self assert: (p3 includesExtensionSelector: #methodDefinedInP3 ofMetaclassName: a2 name).
	self deny: (p3 includesDefinedSelector: #methodDefinedInP3 ofMetaclassName: a2 name).
	
	self deny: (p2 includesSelector: #methodDefinedInP1 ofMetaclassName: a2).
	self assert: (p1 includesExtensionSelector: #methodDefinedInP1 ofMetaclassName: a2 name).
	self assert: (p1 includesExtensionSelector: #methodDefinedInP1 ofClass: a2 class).
	self deny: (p3 includesDefinedSelector: #methodDefinedInP1 ofClassName: a2 name).
	self deny: (p3 includesDefinedSelector: #methodDefinedInP1 ofClass: a2).
! !

!RPackageIncrementalTest methodsFor: 'test extension' stamp: '2010-04-21T09:30:00+01:00'!
testIncludesMethodOfClassInPresenceOfOtherPackageExtensions
	"self debug: #testIncludesMethodOfClassInPresenceOfOtherPackageExtensions"
	
	| p1 p2 p3 a2  a2name |
	p1 := self createNewPackageNamed: 'P1'.
	p2 := self createNewPackageNamed: 'P2'.
	p3 := self createNewPackageNamed: 'P3'.
	a2name := #A2InPackageP2.
	a2 := self createNewClassNamed: a2name inPackage: p2.
	a2 compileSilently: 'methodDefinedInP2 ^ #methodDefinedInP2'.
	p2 addMethod: (a2>>#methodDefinedInP2).
	self assert: (p2 includesDefinedSelector: #methodDefinedInP2 ofClassName: a2name).
	a2 compileSilently: 'methodDefinedInP1 ^ #methodDefinedInP1'.
	p1 addMethod: (a2>>#methodDefinedInP1).
	self assert: (p1 includesExtensionSelector: #methodDefinedInP1 ofClassName: a2name).
	a2 compile: 'methodDefinedInP3 ^ #methodDefinedInP3'.
	p3 addMethod: (a2>>#methodDefinedInP3).
	self assert: (p3 includesExtensionSelector: #methodDefinedInP3 ofClassName: a2name).
		
	self assert: (p2 includesDefinedSelector: #methodDefinedInP2 ofClassName: a2name).
	self deny: (p2 includesDefinedSelector: #methodDefinedInP3 ofClassName: a2name).
	self deny: (p2 includesExtensionSelector: #methodDefinedInP3 ofClassName: a2name).
	self deny: (p2 includesDefinedSelector: #methodDefinedInP1 ofClassName: a2name).
	self deny: (p2 includesExtensionSelector: #methodDefinedInP1 ofClassName: a2name).
	
	
	! !

!RPackageIncrementalTest methodsFor: 'test extension' stamp: '2010-04-25T17:46:00+01:00'!
testIncludesOrTouches
	"self debug: #testIncludesOrTouches"
	
	| p1 p2 a2  |
	p1 := self createNewPackageNamed: 'P1'.
	p2 := self createNewPackageNamed: 'P2'.

	a2 := self createNewClassNamed: #A2InPackageP2 inPackage: p2.
	self deny: (p1 includesClass: a2).
	self assert: (p2 includesClass: a2).
	
	a2 compileSilently: 'methodPackagedInP1 ^ #methodPackagedInP1'.
	p1 addMethod: (a2>>#methodPackagedInP1).
	
	self assert: p1 extensionMethods size = 1.
	self assert: p1 extensionSelectors size = 1.
	self deny: (p1 includesClass: a2).
	self assert: (p1 definesOrExtendsClass: a2).
	self assert: (p2 includesClass: a2).! !

!RPackageIncrementalTest methodsFor: 'test method addition removal' stamp: '2010-03-11T16:50:00+01:00'!
testMethodAddition
	"self debug: #testMethodAddition"

	| p1 a1 methodRef |
	p1 := self createNewPackageNamed: 'P1'.
	a1 := self createNewClassNamed: #A1DefinedInP1 inPackage: p1.
	a1 compileSilently: 'foo ^ 10'.
	p1 addMethod:  (a1>>#foo).
	self assert: (p1 includesSelector: #foo ofClass: a1).
	! !

!RPackageIncrementalTest methodsFor: 'test package belonging' stamp: '2010-04-25T17:33:00+01:00'!
testPackageOfClassForClassesNotDefinedInPackageButJustExtendingIt
	"self debug: #testPackageOfClassForClassesNotDefinedInPackageButJustExtendingIt"
	
	| p1 p2 a2  |
	p1 := self createNewPackageNamed: 'P1'.
	p2 := self createNewPackageNamed: 'P2'.

	a2 := self createNewClassNamed: #A2InPackageP2 inPackage: p2.
	a2 compileSilently: 'methodDefinedInP1 ^ #methodDefinedInP1'.
	p1 addMethod: (a2>>#methodDefinedInP1).
	
	self assert: a2 package = p2.
	p1 extensionMethods do: 
		[:each | self deny: each methodClass package = p1 ].
	"the package of a class which is extended inside a package p, is not p
	but the package where the class was defined"! !

!RPackageIncrementalTest methodsFor: 'test package belonging' stamp: '2010-03-11T16:46:00+01:00'!
testPackageOfClassForDefinedClasses
	"self debug: #testPackageOfClassForDefinedClasses"
	
	| p a1 b1 |
	p := self createNewPackageNamed: 'P1'.
	a1 := self createNewClassNamed: #A1InPAckageP1 inPackage: p.
	b1 := self createNewClassNamed: #B1InPAckageP1 inPackage: p.

	self assert: a1 package = p.
	self assert: b1 package = p.
! !

!RPackageIncrementalTest methodsFor: 'test registration' stamp: '2010-11-26T01:17:00+01:00'!
testRegisterUnregister
	"Verify that when we register a class, the package organizer register it."
	"self debug: #testRegisterUnregister"

	| p a1 b1 |
	p := self createNewPackageNamed: 'P1'.
	a1 := self createNewClassNamed: #A1InPackageP1.
	p definedClassNames add: #A1InPackageP1.
		"ugly but necessary to test registerClass: independant from addClassDefinition:"
	p registerClass: a1.
	self assert: (RPackage organizer packageOf: a1) = p.
	p definedClassNames remove: #A1InPackageP1.
	p unregisterClass: a1.
	self assert: (RPackage organizer packageOf: a1) isDefault.
	
	p definedClassNames add: #A1InPackageP1.
		"ugly but necessary to test registerClass: independant from addClassDefinition:"
	p registerClassName: a1 name.
	self assert: (RPackage organizer packageOf: a1) = p.
	p definedClassNames remove: #A1InPackageP1.
	p unregisterClassName: a1 name.
	self assert: (RPackage organizer packageOf: a1) isDefault
	! !

!RPackageIncrementalTest methodsFor: 'test class addition removal' stamp: '2010-11-26T09:20:00+01:00'!
testRemoveClassAfterMethods
	"self debug: #testRemoveClassAfterMethods"

	| p1 a1 b1 |
	p1 := self createNewPackageNamed: self p1Name.
	"the class is created but not added to the package for now"
	a1 := self createNewClassNamed: #A1InPackageP1 inCategory: self p1Name.
	p1 addClassDefinition: a1.
	self assert: p1 definedClasses size = 1.
	a1 compileSilently: 'newlyAddedToA1 ^ #methodDefinedInP1'.
	p1 addMethod: (a1>>#newlyAddedToA1).
	
	"now we add a new method to the class and the to the package: it is considered
	as defined"
	self deny: (p1 includesExtensionSelector: #newlyAddedToA1 ofClass: a1).
	self assert: (p1 includesDefinedSelector: #newlyAddedToA1 ofClass: a1).
	
	p1 removeClassDefinition: a1.
	self assert: p1 definedClasses size = 0.
	
	self assert: (p1 includesSelector: #newlyAddedToA1 ofClass: a1).
	self assert: (p1 includesExtensionSelector: #newlyAddedToA1 ofClass: a1).
	self deny: (p1 includesDefinedSelector: #newlyAddedToA1 ofClass: a1).
	
	"Now we add the class and this means that the method is not defined anymore but an extension "
	! !

!RPackageIncrementalTest methodsFor: 'test class addition removal' stamp: '2010-11-26T09:20:00+01:00'!
testUniqueClassInDefinedClassesUsingAddClassDefinition
	"self debug: #testUniqueClassInDefinedClassesUsingAddClassDefinition"

	| p a1 |
	p := self createNewPackageNamed: self p1Name.
	a1 := self createNewClassNamed: #A1InPAckageP1 inCategory: self p1Name.
	self assert: p definedClasses size = 0.
	p addClassDefinition: a1.
	self assert: p definedClasses size = 1.
	p addClassDefinition: a1.
	self assert: p definedClasses size = 1.
	p addClassDefinition: a1 class.
	self assert: p definedClasses size = 1.

! !

RPackageIncrementalTest subclass: #RPackageReadOnlyCompleteSetupTest
	instanceVariableNames: 'p1 p2 p3 a1 b1 a2 a3 b2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPackage-Tests'!

!RPackageReadOnlyCompleteSetupTest commentStamp: 'sd 4/22/2010 07:49' prior: 0!
The tests takes as fixture the following situation and exercises the readonly queries.
We should be able to use a test resources to speed it up.

P1 
	A1DefinedInP1
	A1DefinedInP1>>methodDefinedInP1
	B1DefinedInP1	
	A2DefinedInP2>>methodDefinedInP1  (was *P2)
	
P2
	A2DefinedInP2
	A2DefinedInP2>>methodDefinedInP2
	B2DefinedInB2	

P3
	A3DefinedInP3	
	A2DefinedInP2>>methodDefinedInP3  (was *P2*)!

!RPackageReadOnlyCompleteSetupTest methodsFor: 'expectedfailures' stamp: '2010-04-20T21:50:00+01:00'!
expectedFailures

	^ #(testClassNamesAndExtensionSelectorsDo testClassNamesAndExtensionSelectorsDo testClassesAndExtensionMethodsDo testClassesAndExtensionMethodsDo)! !

!RPackageReadOnlyCompleteSetupTest methodsFor: 'setup' stamp: '2010-11-26T09:23:00+01:00'!
setUp

	super setUp.
	p1 := self createNewPackageNamed: self p1Name.
	p2 := self createNewPackageNamed: self p2Name.
	p3 := self createNewPackageNamed: self p3Name.
	
	a1 :=  self createNewClassNamed: #A1DefinedInP1 inPackage: p1.
	b1 := self createNewClassNamed: #B1DefinedInP1 inPackage: p1.
	a2 := self createNewClassNamed: #A2DefinedInP2 inPackage: p2.
	b2 := self createNewClassNamed: #B2DefinedInP2 inPackage: p2.
	a3 := self createNewClassNamed: #A3DefinedInP3 inPackage: p3.
	
	a1 compileSilently: 'methodDefinedInP1 ^ #methodDefinedInP1'.
	p1 addMethod: (a1>>#methodDefinedInP1).
	a1 compileSilently: 'anotherMethodDefinedInP1 ^ #anotherMethodDefinedInP1'.
	p1 addMethod: (a1>>#anotherMethodDefinedInP1).
	
	a2 compileSilently: 'methodDefinedInP1 ^ #methodDefinedInP1'.
	p1 addMethod: (a2>>#methodDefinedInP1).
	
	a2 compileSilently: 'methodDefinedInP2 ^ #methodDefinedInP2'.
	p2 addMethod: (a2>>#methodDefinedInP2).
	
	a2 compileSilently: 'methodDefinedInP3 ^ #methodDefinedInP3'.
	p3 addMethod: (a2>>#methodDefinedInP3).

	a2 class compileSilently: 'classSideMethodDefinedInP3 ^ #classSideMethodDefinedInP3'.
	p3 addMethod: (a2 class>>#classSideMethodDefinedInP3).
	
! !

!RPackageReadOnlyCompleteSetupTest methodsFor: 'test compiled method' stamp: '2010-04-20T22:11:00+01:00'!
testClassIsExtendedInPackage
	"self debug: #testClassIsExtendedInPackage"
	
	self deny: ((Smalltalk at: #A1DefinedInP1) isExtendedInPackage: p1).
	self assert: (p1 includesClass: (Smalltalk at: #A1DefinedInP1)).
	self deny: (p1 extendsClass: (Smalltalk at: #A1DefinedInP1)).
	self assert: ((Smalltalk at: #A2DefinedInP2) isExtendedInPackage: p1).
	self deny: (p1 includesClass: (Smalltalk at: #A2DefinedInP2)).
	self assert: (p1 extendsClass: (Smalltalk at: #A2DefinedInP2)).
	! !

!RPackageReadOnlyCompleteSetupTest methodsFor: 'test slice' stamp: '2010-04-20T21:53:00+01:00'!
testClassNamesAndExtensionSelectorsDo2
	"self debug: #testClassNamesAndExtensionSelectorsDo2"
	

	self assert: (String streamContents: [:stream |
		{p1 . p2 .p3} do: [:p |
			p classNamesAndExtensionSelectorsDo: [:aClassName :selector |
				stream nextPutAll: aClassName  ; nextPutAll: ' ' ; nextPutAll:  selector asString; cr ]]])
		= 'A2DefinedInP2 methodDefinedInP1
A2DefinedInP2 methodDefinedInP3
A2DefinedInP2_class classSideMethodDefinedInP3
'.
! !

!RPackageReadOnlyCompleteSetupTest methodsFor: 'test slice' stamp: '2010-04-20T21:42:00+01:00'!
testClassesAndExtensionMethodsDo
	"self debug: #testClassesAndExtensionMethodsDo"
	
	| block |

	self assert: (String streamContents: [:stream |
		block := [ :aClass :selectors |
				stream nextPutAll: aClass name ; nextPutAll: ' '.
				selectors do: [ :selector | stream nextPutAll: selector asString].
				stream cr.].
		{p1 . p2 . p3} do: [ :p |
			p classExtensionSlicesDo: block.
			p metaclassExtensionSlicesDo: block.]]) 
		= 'A2DefinedInP2 methodDefinedInP1
A2DefinedInP2 methodDefinedInP3
A2DefinedInP2 classSideMethodDefinedInP3
'! !

!RPackageReadOnlyCompleteSetupTest methodsFor: 'test compiled method' stamp: '2010-04-20T21:49:00+01:00'!
testCompiledMethodIsDefinedInPackage
	"self debug: #testCompiledMethodIsDefinedInPackage"
	
	self assert: (((Smalltalk at: #A1DefinedInP1) >> #methodDefinedInP1) isDefinedInPackage: p1).
	self deny: (((Smalltalk at: #A2DefinedInP2) >> #methodDefinedInP1) isDefinedInPackage: p1).
	! !

!RPackageReadOnlyCompleteSetupTest methodsFor: 'test compiled method' stamp: '2010-03-16T17:44:00+01:00'!
testCompiledMethodIsExtensionInPackage
	"self debug: #testCompiledMethodIsExtensionInPackage"
	
	self deny: (((Smalltalk at: #A1DefinedInP1) >> #methodDefinedInP1) isExtensionInPackage: p1).
	self assert: (((Smalltalk at: #A2DefinedInP2) >> #methodDefinedInP1) isExtensionInPackage: p1).
	! !

!RPackageReadOnlyCompleteSetupTest methodsFor: 'test compiled method' stamp: '2010-06-13T17:31:00+01:00'!
testCompiledMethodPackageFromOrganizer
	"self debug: #testCompiledMethodPackageFromOrganizer"
	| method |
	method := (Smalltalk at: #A1DefinedInP1) >> #methodDefinedInP1.
	self assert: (method packageFromOrganizer: RPackage organizer) = p1.
	method := (Smalltalk at: #A2DefinedInP2) >> #methodDefinedInP1.
	self assert: (method packageFromOrganizer: RPackage organizer) = p1! !

!RPackageReadOnlyCompleteSetupTest methodsFor: 'test situation' stamp: '2010-04-21T15:57:00+01:00'!
testDefinedSelectorsForClass
	"self debug: #testDefinedSelectorsForClass"
	
	self assert: (p1 definedSelectorsForClass: a1) size = 2. 
	self assert: (p1 definedMethodsForClass: a1) size = 2. 
	self assert: ((p1 definedSelectorsForClass: a1) includes: #methodDefinedInP1).
	self assert: ((p1 definedSelectorsForClass: a1) includes: #anotherMethodDefinedInP1).
	self assert: ((p1 definedMethodsForClass: a1) includes: ((Smalltalk at: #A1DefinedInP1)>>#methodDefinedInP1)).
	self assert: (p1 definedSelectorsForClass: Object) isEmpty. 
	self assert: (p1 definedSelectorsForClass: Object class) isEmpty. 
! !

!RPackageReadOnlyCompleteSetupTest methodsFor: 'test accessing' stamp: '2010-04-21T17:07:00+01:00'!
testExtendingPackagesOfClass
	"since a class can be extended by several packages, we want the list of packages that extend
	the class"
	
	"self debug: #testExtendingPackagesOfClass"
		
	| packages |
	packages := a2 extendingPackages.
	"a2 is extended by p1 and p3"
	self assert: packages size = 2. 
	self assert: (packages includes: p1).
	self deny: (packages includes: p2).
	self assert: (packages includes: p3).
	
	packages := a1 extendingPackages.
	self assert: packages isEmpty. ! !

!RPackageReadOnlyCompleteSetupTest methodsFor: 'test accessing' stamp: '2010-10-27T15:49:00+01:00'!
testExtensionMethods
	"a package can extend several classes, either the class or  the meta-class side. 'extensionMethods' should list all the methods involved in shuch extensions. P3 extend a2 and a2 class"
	
	"self debug: #testExtendingPackagesOfClass"
		
	|package extensionMethods cpt |
	package := p3.
	self shouldnt: [extensionMethods := package extensionMethods] raise: Error.
	"self assert: (extensionMethods size = 2)."
	self assert: (extensionMethods includes: (a2>>#methodDefinedInP3)).
	self assert: (extensionMethods includes: (a2 class>>#classSideMethodDefinedInP3)).	

	cpt := 0.
	package metaclassExtensionSlicesDo: [:className :listOfSelectors |
		((className = a2 name) and: [listOfSelectors includes: #classSideMethodDefinedInP3])
			ifTrue: [cpt := cpt + 1].
		].	
	self assert: cpt = 1.
	
	cpt := 0.
	package classExtensionSlicesDo: [:className :listOfSelectors |
		((className = a2 name) and: [listOfSelectors includes: #methodDefinedInP3])
			ifTrue: [cpt := cpt + 1].
		].	
	self assert: cpt = 1.! !

!RPackageReadOnlyCompleteSetupTest methodsFor: 'test situation' stamp: '2010-04-20T22:05:00+01:00'!
testExtensionSelectorsForClass
	"self debug: #testExtensionSelectorsForClass"
	
	self assert: (p1 extensionSelectorsForClass: a2) size = 1. 
	self assert: ((p1 extensionSelectorsForClass: a2) includes: #methodDefinedInP1).
	self assert: ((p1 extensionMethodsForClass: a2) includes: (Smalltalk at: #A2DefinedInP2) >> #methodDefinedInP1).
	self assert: (p1 extensionSelectorsForClass: Object) isEmpty.
	self assert: (p1 extensionSelectorsForClass: Object class) isEmpty! !

!RPackageReadOnlyCompleteSetupTest methodsFor: 'test situation' stamp: '2010-03-13T13:48:00+01:00'!
testMetaclassHasExtensions
	"self debug: #testMetaclassHasExtensions"

	self assert: (p3 includesExtensionSelector: #methodDefinedInP3 ofClassName: a2  name).
	self assert: (p3 includesExtensionSelector: #methodDefinedInP3 ofClass: a2).
	self assert: (p3 includesExtensionSelector: #classSideMethodDefinedInP3 ofMetaclassName: a2 name).
	self assert: (p3 includesExtensionSelector: #classSideMethodDefinedInP3 ofClass: a2 class)

	! !

!RPackageReadOnlyCompleteSetupTest methodsFor: 'test situation' stamp: '2010-04-21T16:38:00+01:00'!
testMethods
	"self debug: #testMethods"
	
	| m1 m3 |
	m1 := p1 methods.
	self assert: m1 size = 3. 
	self assert: (m1 includes: a1>>#methodDefinedInP1).
	self assert: (m1 includes: a1>>#anotherMethodDefinedInP1). 
	self assert: (m1 includes: a2>>#methodDefinedInP1).
	m3 := p3 methods.
	self assert: m3 size = 2.
	self assert: (m3 includes: a2>>#methodDefinedInP3).
	self assert: (m3 includes: a2 class>>#classSideMethodDefinedInP3)! !

!RPackageReadOnlyCompleteSetupTest methodsFor: 'test situation' stamp: '2010-04-21T15:57:00+01:00'!
testMethodsForClass
	"self debug: #testMethodsForClass"
	
	self assert: (p1 methodsForClass: a1) size = 2. 
	self assert: ((p1 methodsForClass: a1) includes: ((Smalltalk at: #A1DefinedInP1)>>#methodDefinedInP1)).
	self assert: ((p1 methodsForClass: a1) includes: ((Smalltalk at: #A1DefinedInP1)>>#anotherMethodDefinedInP1)).
	self assert: (p1 methodsForClass: b1) isEmpty. 
	self assert: (p1 methodsForClass: Object) isEmpty. 
	self assert: (p1 methodsForClass: Object class) isEmpty. 

	self assert: (p3 methodsForClass: a2) size = 1.
	self assert: ((p3 methodsForClass: a2) includes: ((Smalltalk at: #A2DefinedInP2)>>#methodDefinedInP3)).
	self assert: (p3 methodsForClass: a2 class) size = 1.
	self assert:  ((p3 methodsForClass: a2 class) includes: ((Smalltalk at: #A2DefinedInP2) class>>#classSideMethodDefinedInP3))	! !

!RPackageReadOnlyCompleteSetupTest methodsFor: 'test accessing' stamp: '2010-04-21T17:08:00+01:00'!
testPackagesOfClass
	"since a class can be extended by several packages, we want the complete list of packages that define or extend
	the class"
	"self debug: #testPackagesOfClass"
		
	| packages extending |
	packages := a2 packages.
	"a2 is extended by p1 and p3"
	extending := a2 extendingPackages.
	self assert: extending size = 2. 
	self assert: (extending includes: p1).
	self assert: (extending includes: p3).
	
	self assert: packages size = 3. 
	self assert: (packages includes: p1).
	self assert: (packages includes: p2).
	self assert: (packages includes: p3).
	
	
	
	
	
	
	! !

!RPackageReadOnlyCompleteSetupTest methodsFor: 'test situation' stamp: '2010-04-21T16:13:00+01:00'!
testSelectors
	"self debug: #testSelectors"
	
	self assert: (p1 selectors) size = 2. 
	self assert: ((p1 selectors) includes: #methodDefinedInP1).
	self assert: ((p1 selectors) includes: #anotherMethodDefinedInP1). 

	self assert: p3 selectors size = 2.
	self assert: (p3 selectors includes: #methodDefinedInP3).
	self assert:  (p3 selectors includes: #classSideMethodDefinedInP3)	! !

!RPackageReadOnlyCompleteSetupTest methodsFor: 'test situation' stamp: '2010-04-21T15:58:00+01:00'!
testSelectorsForClass
	"self debug: #testSelectorsForClass"
	
	self assert: (p1 selectorsForClass: a1) size = 2. 
	self assert: ((p1 selectorsForClass: a1) includes: #methodDefinedInP1).
	self assert: ((p1 selectorsForClass: a1) includes: #anotherMethodDefinedInP1).
	self assert: (p1 selectorsForClass: b1) isEmpty. 
	self assert: (p1 selectorsForClass: Object) isEmpty. 
	self assert: (p1 selectorsForClass: Object class) isEmpty. 

	self assert: (p3 selectorsForClass: a2) size = 1.
	self assert: ((p3 selectorsForClass: a2) includes: #methodDefinedInP3).
	self assert: (p3 selectorsForClass: a2 class) size = 1.
	self assert:  ((p3 selectorsForClass: a2 class) includes: #classSideMethodDefinedInP3)	! !

!RPackageReadOnlyCompleteSetupTest methodsFor: 'test situation' stamp: '2010-03-13T16:54:00+01:00'!
testStartingSituation
	"self debug: #testStartingSituation"
	
	self deny: (p2 includesClass: b1).
	self assert: (p2 includesClass: b2).
	"a locally defined class not extended by other packages"
	
	self assert: (p2 includesClass: a2).  
	"a locally defined class extended by other packages"
	
	self assert: (p1 definesOrExtendsClass: a2).
	self deny: (p1 includesClass: a2).! !

RPackageTestCase subclass: #RPackageOrganizerTest
	instanceVariableNames: 'createdClasses createdPackages organizer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPackage-Tests'!

!RPackageOrganizerTest methodsFor: 'utility' stamp: '2010-06-05T18:28:00+01:00'!
createNewClassNamed: aName
	
	| cls |
	cls := Object subclass: aName
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: 'RPackageTest'.
	createdClasses add: cls.
	^ cls! !

!RPackageOrganizerTest methodsFor: 'utility' stamp: '2010-06-05T18:28:00+01:00'!
createNewClassNamed: aName inCategory: cat
	
	| cls |
	cls := Object subclass: aName
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: cat.
	createdClasses add: cls.
	^ cls! !

!RPackageOrganizerTest methodsFor: 'utility' stamp: '2010-06-05T18:28:00+01:00'!
createNewClassNamed: aName inPackage: p
	
	| cls |
	cls := self createNewClassNamed: aName.
	p addClassDefinition: cls.
	^ cls! !

!RPackageOrganizerTest methodsFor: 'utility' stamp: '2010-06-05T18:28:00+01:00'!
createNewPackageNamed: aName

	| pack |
	self removePackageIfExist: aName.
	pack := self packageClass named: aName.
	createdPackages add: pack.
	^ pack! !

!RPackageOrganizerTest methodsFor: 'utility' stamp: '2010-06-05T18:40:00+01:00'!
packageClass

	^ RPackage! !

!RPackageOrganizerTest methodsFor: 'utility' stamp: '2011-01-31T11:40:00+01:00'!
packageOrganizer
	^ organizer ifNil: [organizer := RPackageOrganizer basicNew initialize]! !

!RPackageOrganizerTest methodsFor: 'tests extending' stamp: '2010-06-13T22:12:00+01:00'!
pointRectangleInGraphElement 
	| p |
	p := RPackage named: #GraphElement.
	p addClassDefinition: Point.
	p addMethod: Point>>#x.
	p addMethod: Point>>#rotateBy:about:. 
	p addClassDefinition: Rectangle.
	p addMethod: Quadrangle>>#intersect:.
	^ p! !

!RPackageOrganizerTest methodsFor: 'utility' stamp: '2010-07-29T21:54:00+01:00'!
removeClassNamedIfExists: aClassNameSymbol

	Smalltalk globals at: aClassNameSymbol asSymbol ifPresent: [ :c | c removeFromSystem ]! !

!RPackageOrganizerTest methodsFor: 'utility' stamp: '2010-06-05T18:28:00+01:00'!
removePackageIfExist: aName

	self flag: #toDo.
	! !

!RPackageOrganizerTest methodsFor: 'setup' stamp: '2010-06-13T17:49:00+01:00'!
setUp
	createdClasses := OrderedCollection new.
	createdPackages := OrderedCollection new.! !

!RPackageOrganizerTest methodsFor: 'tests extending' stamp: '2010-06-13T22:13:00+01:00'!
stringCharacterInCollPackage
	| p |
	p := RPackage named: #CollPackage.
	p addClassDefinition: String.
	p addClassDefinition: Character.
	p addMethod: String>>#indexOf:.
	p addMethod: String>>#isAllDigits.
	p addMethod: String class>>#cr.
	p addMethod: Character>>#asInteger.
	p addMethod: Text>>#allBold.
	^ p! !

!RPackageOrganizerTest methodsFor: 'setup' stamp: '2010-06-13T17:58:00+01:00'!
tearDown 
	(createdClasses reject: [:c| c isObsolete])
		do: [:cls| 
				(self packageClass packageOrganizerClass default includesClass: cls)
					ifTrue: [self packageOrganizer unregisterClass: cls.].
				cls removeFromSystem ].
	createdPackages do:
		[:each | self packageOrganizer unregisterPackage: each]! !

!RPackageOrganizerTest methodsFor: 'tests' stamp: '2010-11-26T01:42:00+01:00'!
testAccessingPackage
	"self debug: #testAccessingPackage"

	| p1 |
	p1 := self createNewPackageNamed: 'P1'.
	self packageOrganizer registerPackage: p1.
	p1 addClassDefinition: Point.
	p1 addMethod: Point>>#x.
	p1 addMethod: Point class>>#x:y:. 
	self assert: (self packageOrganizer packageNamed: #P1) = p1.
	self should: [(self packageOrganizer packageNamed: #P22)] raise: Error! !

!RPackageOrganizerTest methodsFor: 'tests' stamp: '2010-11-26T01:42:00+01:00'!
testDefinedClassesInstanceAndMetaSideAPI
	"self debug: #testDefinedClassesInstanceAndMetaSideAPI"
	| p1 |
	p1 := self createNewPackageNamed: 'P1'.
	self packageOrganizer registerPackage: p1.
	p1 addClassDefinition: Point.
	p1 addMethod: Point>>#x.
	p1 addMethod: Point class>>#x:y:. 
	self assert: self packageOrganizer packageNames size = 2.
	self assert: self packageOrganizer packages size = 2.
	self assert: (self packageOrganizer packageNamed: #P1) definedClasses size = 1! !

!RPackageOrganizerTest methodsFor: 'tests' stamp: '2010-11-26T01:42:00+01:00'!
testEmpty
	"self debug: #testEmpty"
	self assert: self packageOrganizer packageNames size = 1.
	self assert: (self packageOrganizer packageNames includes: RPackage defaultPackageName)
! !

!RPackageOrganizerTest methodsFor: 'tests' stamp: '2010-11-26T01:41:00+01:00'!
testRegisteredIsIncludedInPackageNames
	"self debug: #testRegisteredIsIncludedInPackageNames"
	| p1 p2 p3 |
	p1 := self createNewPackageNamed: 'P1'.
	p2 := self createNewPackageNamed: 'P2'.
	p3 := self createNewPackageNamed: 'P3'.

	self packageOrganizer registerPackage: p1.
	self packageOrganizer registerPackage: p2.
	self packageOrganizer registerPackage: p3.
	self assert: self packageOrganizer packageNames size = 4.
	self assert: (self packageOrganizer includesPackage: p1). 
	self assert: (self packageOrganizer includesPackageNamed: p1 name). 
	{p1 . p2 . p3} do: [:each | self assert:  (self packageOrganizer packageNames includes: each name)]

! !

!RPackageOrganizerTest methodsFor: 'tests' stamp: '2010-11-26T01:41:00+01:00'!
testRegisteredIsThere
	"self debug: #testRegisteredIsThere"

	| p1 p2 p3 |
	p1 := self createNewPackageNamed: 'P1'.
	p2 := self createNewPackageNamed: 'P2'.
	p3 := self createNewPackageNamed: 'P3'.

	self packageOrganizer registerPackage: p1.
	self packageOrganizer registerPackage: p2.
	self packageOrganizer registerPackage: p3.
	self assert: self packageOrganizer packageNames size = 4.
	
	{p1 . p2 . p3} do: [:each | 
		self assert:  (self packageOrganizer packageNames includes: each name)]! !

!RPackageOrganizerTest methodsFor: 'tests' stamp: '2010-11-26T01:41:00+01:00'!
testRegisteredNumberOfPackageIsOk
	"self debug: #testRegisteredNumberOfPackageIsOk"

	| p1 p2 p3 |
	p1 := self createNewPackageNamed: 'P1'.
	p2 := self createNewPackageNamed: 'P2'.
	p3 := self createNewPackageNamed: 'P3'.

	self packageOrganizer registerPackage: p1.
	self packageOrganizer registerPackage: p2.
	self packageOrganizer registerPackage: p3.
	self assert: self packageOrganizer packageNames size = 4.
	self packageOrganizer unregisterPackage: p3.
	self assert: self packageOrganizer packageNames size = 3.! !

!RPackageOrganizerTest methodsFor: 'tests extending' stamp: '2011-01-31T10:53:00+01:00'!
testRegistrationExtendingPackages
	"self debug: #testRegistrationExtendingPackages"

	| p |
	self assert: (self packageOrganizer extendingPackagesOf: Quadrangle) isEmpty.
	RPackage withOrganizer: (RPackageOrganizer basicNew initialize) do: [p := self pointRectangleInGraphElement].
	"We use this fancy code because we want to make sure that we do not affect the current packageOrganizer.
	Like that this test focuses on the explicit call of the registration"
	(self packageOrganizer
					registerExtendingPackage:  p
					forClass: Quadrangle).
	self deny: (self packageOrganizer extendingPackagesOf: Quadrangle) isEmpty.
	self assert: (self packageOrganizer extendingPackagesOf: Quadrangle) anyOne name = #GraphElement.
	! !

!RPackageOrganizerTest methodsFor: 'tests' stamp: '2010-11-26T01:42:00+01:00'!
testUnregisterBasedOnNames
	"self debug: #testUnregisterBasedOnNames"

	| p1 p2 p3 |
	p1 := self createNewPackageNamed: 'P1'.
	p2 := self createNewPackageNamed: 'P2'.
	p3 := self createNewPackageNamed: 'P3'.

	self packageOrganizer registerPackage: p1.
	self packageOrganizer registerPackage: p2.
	self packageOrganizer registerPackage: p3.
	self assert: self packageOrganizer packageNames size = 4.

	{p1 . p2 . p3} do: [:each | 
		(self packageOrganizer unregisterPackageNamed: each name).
		self deny:  (self packageOrganizer packageNames includes: each name)]! !

!RPackageOrganizerTest methodsFor: 'tests extending' stamp: '2011-01-31T11:52:00+01:00'!
testUnregistrationExtendingPackages
	"self debug: #testUnregistrationExtendingPackages"

	| p |
	p := self pointRectangleInGraphElement.
	self packageOrganizer
		registerExtendingPackage: p
		forClass: Quadrangle.
	self deny: (self packageOrganizer extendingPackagesOf: Quadrangle) isEmpty.
	self assert: (self packageOrganizer extendingPackagesOf: Quadrangle) anyOne name = #GraphElement.
	self packageOrganizer
					unregisterExtendingPackage:  p
					forClass: Quadrangle.
	self assert: (self packageOrganizer extendingPackagesOf: Quadrangle) isEmpty.
	! !

!RPackageTestCase methodsFor: 'accessing' stamp: '2010-11-26T01:36:00+01:00'!
organizer
	^ RPackage organizer! !

!RPackageTestCase methodsFor: 'running' stamp: '2010-07-29T23:11:00+01:00'!
runCase
	^ RPackage 
		withOrganizer: self setupOrganizer
		do: [ super runCase ]! !

!RPackageTestCase methodsFor: 'accessing' stamp: '2011-01-31T10:53:00+01:00'!
setupOrganizer
	^ RPackageOrganizer basicNew initialize! !
MCMockRPackage initialize!
RMockSystemAnnouncer initialize!
